class
	DB_HANDLER

create
	make

feature -- Control

	make
		do
			create db_application
			db_application.set_hostname (db_hostname)
			db_application.set_data_source (db_data_source)
			db_application.login (db_username, db_password)
			db_application.set_base

			create db_control.make
			db_control.connect

			if not db_control.is_connected then
				io.put_string ("Could not connect to database.%N")
			else
				io.put_string ("Connected to database.%N")
			end
		end

	disconnect
		do
			if db_control.is_connected then
				db_control.disconnect
				io.put_string ("Disconnected from database.%N")
			end
		end

feature {NONE} -- Database access

	db_application: DATABASE_APPL [ODBC]
			-- Database application to use.

	db_control: DB_CONTROL
			-- Database control.

	db_repositories: HASH_TABLE [DB_REPOSITORY, STRING]
			-- Database repositories mapped to the table name.

feature {NONE} -- DB config

	db_hostname: STRING is "localhost"
			-- Database hostname

	db_data_source: STRING is "test"
			-- Database source

	db_username: STRING is "test"
			-- Database username

	db_password: STRING is "pass"
			-- Database password

end
