class
	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- Run application.
		do
			-- init db connection
			create db_handler.make

			-- run tests
			io.put_string ("%NRetrieve relation with mapping%N")
			retrieve_with_mapping ("id_1")
			retrieve_with_mapping ("id_2")

			io.put_string ("%NRetrieve relation with hardcoded id%N")
			retrieve_hardcoded ("id_3")
			retrieve_hardcoded ("id_4")

			db_handler.disconnect
		end

feature --retrieval

	retrieve_with_mapping (an_id: STRING)
			-- Retrieve a value from the database by `an_id'
		local
			l_selection: DB_SELECTION
			l_query: STRING
		do
			create l_selection.make

			l_selection.set_map_name (an_id, "id_map")
			create l_query.make_from_string ("SELECT * FROM `test_table` WHERE id=:id_map")
			l_selection.query (l_query)

			fetch_and_print_results (l_selection)
		end

	retrieve_hardcoded (an_id: STRING)
			-- Retrieve a value from the database by `an_id'
		local
			l_selection: DB_SELECTION
			l_query: STRING
		do
			create l_selection.make

			create l_query.make_from_string ("SELECT * FROM `test_table` WHERE id='" + an_id + "'")
			l_selection.query (l_query)

			fetch_and_print_results(l_selection)
		end

feature {NONE} -- Implementation

	fetch_and_print_results (a_selection: DB_SELECTION)
			-- Retrieves the values from the selection and prints the relations.
		local
			l_list_filling: DB_ACTION [DATA]
			l_data: DATA
			l_data_list: LIST [DATA]

			l_id: STRING
			l_value: STRING
		do
			create l_data

			a_selection.object_convert (l_data)
			create l_list_filling.make (a_selection, l_data)
			a_selection.set_action (l_list_filling)

			a_selection.load_result
			a_selection.terminate

			l_data_list := l_list_filling.list
			if l_data_list.count = 0 then
				io.put_string ("No relations retrieved.%N")
			else
				from l_data_list.start
				until l_data_list.after
				loop
					l_id := l_data_list.item_for_iteration.id
					if l_data_list.item_for_iteration.id = Void then
						l_id := "< -1 >"
					end

					l_value := l_data_list.item_for_iteration.value
					if l_data_list.item_for_iteration.value = Void then
						l_value := "< NONE >"
					end

					io.put_string("Retrieved relation: id=" + l_id + ", value: " + l_value + "%N")

					-- increment
					l_data_list.forth
				end
			end
		end

feature {NONE} -- DB access

	db_handler: DB_HANDLER
			-- Connection handler for the database

end
